Package org.snpeff.interval

# Class GffMarker

java.lang.Object
org.snpeff.interval.Interval
org.snpeff.interval.Marker
org.snpeff.interval.Custom
org.snpeff.interval.GffMarker

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Comparable<Interval>`, `Iterable<KeyValue<String,String>>`, `TxtSerializable`

Direct Known Subclasses:
  `Gtf2Marker`

public class GffMarker extends Custom
An interval intended as a mark

Author:
  pcingola
See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`FIELD_BIOTYPE`
`static final String`
`FIELD_DB_XREF`
`static final String`
`FIELD_EXON_ID`
`static final String`
`FIELD_GENE`
`static final String`
`FIELD_GENE_BIOTYPE`
`static final String`
`FIELD_GENE_ID`
`static final String`
`FIELD_GENE_NAME`
`static final String`
`FIELD_GENE_TYPE`
`static final String`
`FIELD_ID`
`static final String`
`FIELD_NAME`
`static final String`
`FIELD_NAMEU`
`static final String`
`FIELD_PARENT`
`static final String`
`FIELD_PROTEIN_ID`
`static final String`
`FIELD_TAG`
`static final String`
`FIELD_TRANSCRIPT_ID`
`static final String`
`FIELD_TRANSCRIPT_TSL`
`static final String`
`FIELD_TRANSCRIPT_VERSION`
`static final String`
`MULTIPLE_VALUES_SEPARATOR`

### Fields inherited from class org.snpeff.interval.Marker

`type`

### Fields inherited from class org.snpeff.interval.Interval

`chromosomeNameOri, end, id, parent, start, strandMinus`

## Constructor Summary

Constructors
Constructor
Description
`GffMarker()`
`GffMarker(Genome genome, String line)`
`GffMarker(Marker parent, int start, int end, boolean strandMinus, String id)`

## Method Summary

Modifier and Type
Method
Description
`void`
`add(String key, String value)`
Add key value pair
`static boolean`
`canParseLine(String line)`
Can this line (form a GFF file) be parsed? Note: Returns false for headers, empty lines and lines having less number of fields than expected
`String`
`getAttr(String key)`
`BioType`
`getBiotype()`
`protected String`
`getBioType()`
`protected BioType`
`getBiotypeGeneric()`
`int`
`getFrame()`
`BioType`
`getGeneBiotype()`
`String`
`getGeneId()`
`String`
`getGeneName()`
`String`
`getGffParentId(boolean doNotRecurse)`
`String[]`
`getGffParentIds()`
Parent can have multiple, comma separated entries
`GffType`
`getGffType()`
`String`
`getProteinId()`
`String`
`getTags()`
`BioType`
`getTranscriptBiotype()`
`String`
`getTranscriptId()`
`String`
`getTranscriptTsl()`
`String`
`getTranscriptVersion()`
`boolean`
`hasAnnotations()`
When annotating a VCF file, add fields from this GFF
`boolean`
`hasAttr(String key)`
`boolean`
`isMultipleValues(String key)`
Does the key have mutiple values
`boolean`
`isProteingCoding()`
Is biotType considered 'protein coding'?
`Iterator<KeyValue<String,String>>`
`iterator()`
`protected void`
`parse(Genome genome, String line)`
Parse an entry (line) from a GFF file
`protected void`
`parseAttributes(String attrStr)`
Parse attributes (key-value pairs) from a line in a GFF file
`protected String`
`parseId()`
Obtain or create an ID
`String`
`toString()`

### Methods inherited from class org.snpeff.interval.Custom

`cloneShallow, getLabel, getScore, setLabel, setScore, variantEffect`

### Methods inherited from class org.snpeff.interval.Marker

`adjust, apply, applyDel, applyDup, applyIns, applyMixed, clone, codonTable, compareTo, compareToPos, distance, distanceBases, getParent, getType, idChain, idChain, idChain, includes, intersect, isAdjustIfParentDoesNotInclude, isDeferredAnalysis, isShowWarningIfParentDoesNotInclude, minus, query, query, readTxt, serializeParse, serializeSave, shouldApply, union, variantEffectNonRef`

### Methods inherited from class org.snpeff.interval.Interval

`equals, findParent, getChromosome, getChromosomeName, getChromosomeNameOri, getChromosomeNum, getEnd, getGenome, getGenomeName, getId, getStart, getStrand, hashCode, intersects, intersects, intersects, intersects, intersectSize, isCircular, isSameChromo, isStrandMinus, isStrandPlus, isValid, setChromosomeNameOri, setEnd, setId, setParent, setStart, setStrandMinus, shiftCoordinates, size, toStr, toStringAsciiArt, toStrPos`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.lang.Iterable

`forEach, spliterator`

## Field Details

### MULTIPLE_VALUES_SEPARATOR

public static final String MULTIPLE_VALUES_SEPARATOR

See Also:
  - Constant Field Values

### FIELD_BIOTYPE

public static final String FIELD_BIOTYPE

See Also:
  - Constant Field Values

### FIELD_DB_XREF

public static final String FIELD_DB_XREF

See Also:
  - Constant Field Values

### FIELD_EXON_ID

public static final String FIELD_EXON_ID

See Also:
  - Constant Field Values

### FIELD_GENE

public static final String FIELD_GENE

See Also:
  - Constant Field Values

### FIELD_GENE_BIOTYPE

public static final String FIELD_GENE_BIOTYPE

See Also:
  - Constant Field Values

### FIELD_GENE_ID

public static final String FIELD_GENE_ID

See Also:
  - Constant Field Values

### FIELD_GENE_NAME

public static final String FIELD_GENE_NAME

See Also:
  - Constant Field Values

### FIELD_GENE_TYPE

public static final String FIELD_GENE_TYPE

See Also:
  - Constant Field Values

### FIELD_ID

public static final String FIELD_ID

See Also:
  - Constant Field Values

### FIELD_NAME

public static final String FIELD_NAME

See Also:
  - Constant Field Values

### FIELD_NAMEU

public static final String FIELD_NAMEU

See Also:
  - Constant Field Values

### FIELD_PARENT

public static final String FIELD_PARENT

See Also:
  - Constant Field Values

### FIELD_PROTEIN_ID

public static final String FIELD_PROTEIN_ID

See Also:
  - Constant Field Values

### FIELD_TAG

public static final String FIELD_TAG

See Also:
  - Constant Field Values

### FIELD_TRANSCRIPT_ID

public static final String FIELD_TRANSCRIPT_ID

See Also:
  - Constant Field Values

### FIELD_TRANSCRIPT_TSL

public static final String FIELD_TRANSCRIPT_TSL

See Also:
  - Constant Field Values

### FIELD_TRANSCRIPT_VERSION

public static final String FIELD_TRANSCRIPT_VERSION

See Also:
  - Constant Field Values

## Constructor Details

### GffMarker

public GffMarker()

### GffMarker

public GffMarker(Genome genome, String line)

### GffMarker

public GffMarker(Marker parent, int start, int end, boolean strandMinus, String id)

## Method Details

### canParseLine

public static boolean canParseLine(String line)
Can this line (form a GFF file) be parsed? Note: Returns false for headers, empty lines and lines having less number of fields than expected

### add

public void add(String key, String value)
Add key value pair

### getAttr

public String getAttr(String key)

### getBiotype

public BioType getBiotype()

### getBioType

protected String getBioType()

### getBiotypeGeneric

protected BioType getBiotypeGeneric()

### getFrame

public int getFrame()

### getGeneBiotype

public BioType getGeneBiotype()

### getGeneId

public String getGeneId()

### getGeneName

public String getGeneName()

### getGffParentId

public String getGffParentId(boolean doNotRecurse)

### getGffParentIds

public String[] getGffParentIds()
Parent can have multiple, comma separated entries

### getGffType

public GffType getGffType()

### getProteinId

public String getProteinId()

### getTranscriptBiotype

public BioType getTranscriptBiotype()

### getTags

public String getTags()

### getTranscriptTsl

public String getTranscriptTsl()

### getTranscriptId

public String getTranscriptId()

### getTranscriptVersion

public String getTranscriptVersion()

### hasAnnotations

public boolean hasAnnotations()
When annotating a VCF file, add fields from this GFF

Overrides:
  `hasAnnotations` in class `Custom`

### hasAttr

public boolean hasAttr(String key)

### isMultipleValues

public boolean isMultipleValues(String key)
Does the key have mutiple values

### isProteingCoding

public boolean isProteingCoding()
Is biotType considered 'protein coding'?

### iterator

public Iterator<KeyValue<String,String>> iterator()

Specified by:
  `iterator` in interface `Iterable<KeyValue<String,String>>`
Overrides:
  `iterator` in class `Custom`

### parse

protected void parse(Genome genome, String line)
Parse an entry (line) from a GFF file

### parseAttributes

protected void parseAttributes(String attrStr)
Parse attributes (key-value pairs) from a line in a GFF file

### parseId

protected String parseId()
Obtain or create an ID

### toString

public String toString()

Overrides:
  `toString` in class `Custom`